Index: XIOS/dev/branch_openmp/src/parse_expr/filter_expr_node.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/parse_expr/filter_expr_node.hpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/parse_expr/filter_expr_node.hpp	(revision 1545)
@@ -3,5 +3,4 @@
 
 #include <string>
-#include <boost/shared_ptr.hpp>
 #include <boost/smart_ptr/scoped_ptr.hpp>
 #include "scalar_expr_node.hpp"
@@ -26,5 +25,5 @@
      * \return the output pin of the filter producing the result of the expression 
      */
-    virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const = 0;
+    virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const = 0;
   };
 
@@ -43,5 +42,5 @@
       CFilterFieldExprNode(const std::string& fieldId);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -64,5 +63,5 @@
       CFilterTemporalFieldExprNode(const std::string& fieldId);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -87,5 +86,5 @@
       CFilterUnaryOpExprNode(const std::string& opId, IFilterExprNode* child);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -112,5 +111,5 @@
       CFilterScalarFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -138,5 +137,5 @@
       CFilterFieldScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -163,5 +162,5 @@
       CFilterFieldFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -191,5 +190,5 @@
       CFilterScalarScalarFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -220,5 +219,5 @@
       CFilterScalarFieldScalarOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -249,5 +248,5 @@
       CFilterScalarFieldFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -279,5 +278,5 @@
       CFilterFieldScalarScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -308,5 +307,5 @@
       CFilterFieldScalarFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -336,5 +335,5 @@
       CFilterFieldFieldScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
@@ -365,5 +364,5 @@
       CFilterFieldFieldFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3);
 
-      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+      virtual std::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
 
     private:
Index: XIOS/dev/branch_openmp/src/server.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/server.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/server.cpp	(revision 1545)
@@ -39,5 +39,4 @@
  * \fn void CServer::initialize(void)
  * Creates intraComm for each possible type of servers (classical, primary or secondary).
- * (For now the assumption is that there is one proc per secondary server pool.)
  * Creates interComm and stores them into the following lists:
  *   classical server -- interCommLeft
@@ -111,8 +110,9 @@
           else
           {
+            if (CXios::nbPoolsServer2 == 0) CXios::nbPoolsServer2 = reqNbProc;
             int firstSndSrvRank = srvRanks.size()*(100.-CXios::ratioServer2)/100. ;
             int poolLeader = firstSndSrvRank;
 //*********** (1) Comment out the line below to set one process per pool
-//            sndServerGlobalRanks.push_back(srvRanks[poolLeader]);
+            sndServerGlobalRanks.push_back(srvRanks[poolLeader]);
             int nbPools = CXios::nbPoolsServer2;
             if ( nbPools > reqNbProc || nbPools < 1)
@@ -140,8 +140,8 @@
                 }
 //*********** (2) Comment out the two lines below to set one process per pool
-//                if (poolLeader < srvRanks.size())
-//                  sndServerGlobalRanks.push_back(srvRanks[poolLeader]);
+                if (poolLeader < srvRanks.size())
+                  sndServerGlobalRanks.push_back(srvRanks[poolLeader]);
 //*********** (3) Uncomment the line below to set one process per pool
-                sndServerGlobalRanks.push_back(srvRanks[i]);
+//                sndServerGlobalRanks.push_back(srvRanks[i]);
               }
               else
@@ -189,4 +189,6 @@
               MPI_Comm_size(intraComm,&intraCommSize) ;
               MPI_Comm_rank(intraComm,&intraCommRank) ;
+
+              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
               #pragma omp critical (_output)
               {
@@ -195,5 +197,5 @@
               }
 
-              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+              
               interCommLeft.push_back(newComm) ;
             }
@@ -213,4 +215,6 @@
               MPI_Comm_size(intraComm, &intraCommSize) ;
               MPI_Comm_rank(intraComm, &intraCommRank) ;
+              
+              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
               #pragma omp critical (_output)
               {
@@ -218,5 +222,5 @@
                        <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
               }
-              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+
               interCommLeft.push_back(newComm) ;
             }
@@ -228,4 +232,6 @@
             MPI_Comm_size(intraComm, &intraCommSize) ;
             MPI_Comm_rank(intraComm, &intraCommRank) ;
+
+            MPI_Intercomm_create(intraComm, 0, CXios::globalComm, sndServerGlobalRanks[i], 1, &newComm) ;
             #pragma omp critical (_output)
             {
@@ -233,5 +239,5 @@
                 <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< sndServerGlobalRanks[i]<<endl ;
             }
-            MPI_Intercomm_create(intraComm, 0, CXios::globalComm, sndServerGlobalRanks[i], 1, &newComm) ;
+
             interCommRight.push_back(newComm) ;
           }
@@ -244,4 +250,6 @@
           MPI_Comm_size(intraComm, &intraCommSize) ;
           MPI_Comm_rank(intraComm, &intraCommRank) ;
+
+          MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 1, &newComm) ;
           #pragma omp critical (_output)
           {
@@ -250,5 +258,4 @@
           }
 
-          MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 1, &newComm) ;
           interCommLeft.push_back(newComm) ;
         }
@@ -654,10 +661,7 @@
        if (flag==true)
        {
-         int my_count;
          counts.push_back(0);
          MPI_Get_count(&status,MPI_CHAR,&(counts.back())) ;
          buffers.push_back(new char[counts.back()]) ;
-         //requests.push_back(request);
-         //MPI_Irecv((void*)(buffers.back()),counts.back(),MPI_CHAR,root,2,intraComm,&(requests.back())) ;
          MPI_Irecv((void*)(buffers.back()),counts.back(),MPI_CHAR,root,2,intraComm,&request) ;
          requests.push_back(request);
@@ -817,5 +821,5 @@
       if (!fb->is_open())
         ERROR("void CServer::openStream(const StdString& fileName, const StdString& ext, std::filebuf* fb)",
-              << std::endl << "Can not open <" << fileNameClient << "> file to write the server log(s).");
+              << std::endl << "Can not open <" << fileNameClient.str() << "> file to write the server log(s).");
     }
 
Index: XIOS/dev/branch_openmp/src/server_distribution_description.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/server_distribution_description.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/server_distribution_description.cpp	(revision 1545)
@@ -196,5 +196,5 @@
   \param [in] positionDimensionDistributed dimension of server on which we make the cut.
 */
-std::vector<int> CServerDistributionDescription::computeServerGlobalByElement(std::vector<boost::unordered_map<size_t,std::vector<int> > >& indexServerOnElement,
+std::vector<int> CServerDistributionDescription::computeServerGlobalByElement(std::vector<std::unordered_map<size_t,std::vector<int> > >& indexServerOnElement,
                                                                               int clientRank,
                                                                               int clientSize,
@@ -510,5 +510,5 @@
   Get global index calculated by computeServerGlobalIndexInRange
 */
-const boost::unordered_map<size_t,int>& CServerDistributionDescription::getGlobalIndexRange() const
+const std::unordered_map<size_t,int>& CServerDistributionDescription::getGlobalIndexRange() const
 {
   return globalIndex_;
Index: XIOS/dev/branch_openmp/src/server_distribution_description.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/server_distribution_description.hpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/server_distribution_description.hpp	(revision 1545)
@@ -13,5 +13,5 @@
 #include "xios_spl.hpp"
 #include "array_new.hpp"
-#include <boost/unordered_map.hpp>
+#include <unordered_map>
 
 namespace xios
@@ -39,5 +39,5 @@
     void computeServerDistribution(bool doComputeGlobalIndex = false, int positionDimensionDistributed = 1);
     std::vector<int> computeServerGlobalIndexInRange(const std::pair<size_t, size_t>& indexBeginEnd, int positionDimensionDistributed = 1);
-    std::vector<int> computeServerGlobalByElement(std::vector<boost::unordered_map<size_t,std::vector<int> > >& indexServerOnElement,
+    std::vector<int> computeServerGlobalByElement(std::vector<std::unordered_map<size_t,std::vector<int> > >& indexServerOnElement,
                                                   int rank,
                                                   int clientSize,
@@ -48,5 +48,5 @@
     std::vector<std::vector<int> > getServerDimensionSizes() const;
     const std::vector<CArray<size_t,1> >& getGlobalIndex() const;
-    const boost::unordered_map<size_t,int>& getGlobalIndexRange() const;
+    const std::unordered_map<size_t,int>& getGlobalIndexRange() const;
     int getDimensionDistributed();
 
@@ -73,5 +73,5 @@
 
     //!< In case we need only global index of one server with specific rank
-    boost::unordered_map<size_t,int> globalIndex_;
+    std::unordered_map<size_t,int> globalIndex_;
 
     //!< Type of distribution on server side
Index: XIOS/dev/branch_openmp/src/timer.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/timer.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/timer.cpp	(revision 1545)
@@ -10,5 +10,4 @@
 namespace xios
 {
-  //std::map<std::string,CTimer> CTimer::allTimer;
   std::map<std::string,CTimer> *CTimer::allTimer_ptr = 0;
   
@@ -58,11 +57,9 @@
     if(allTimer_ptr == NULL) allTimer_ptr = new std::map<std::string,CTimer>;
 
-    //std::map<std::string,CTimer>::iterator it = allTimer.find(name);
     std::map<std::string,CTimer>::iterator it = allTimer_ptr->find(name);
-    //if (it == allTimer.end())
+
     if (it == allTimer_ptr->end())
       it = allTimer_ptr->insert(std::make_pair(name, CTimer(name))).first;
 
-      //it = allTimer.insert(std::make_pair(name, CTimer(name))).first;
     return it->second;
   }
@@ -72,5 +69,5 @@
     std::ostringstream strOut ;
     if(allTimer_ptr == 0) allTimer_ptr = new std::map<std::string,CTimer>;
-    //for(std::map<std::string,CTimer>::iterator it=allTimer.begin();it!=allTimer.end();++it)
+
     for(std::map<std::string,CTimer>::iterator it=allTimer_ptr->begin();it!=allTimer_ptr->end();++it)
       strOut<<"Timer : "<<it->first<<"    -->   cumulated time : "<<it->second.getCumulatedTime()<<std::endl ;
Index: XIOS/dev/branch_openmp/src/timer.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/timer.hpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/timer.hpp	(revision 1545)
@@ -20,5 +20,4 @@
       void reset(void);
       double getCumulatedTime(void);
-      //static std::map<std::string,CTimer> allTimer;
       static std::map<std::string,CTimer> *allTimer_ptr;
       #pragma omp threadprivate(allTimer_ptr)
Index: XIOS/dev/branch_openmp/src/transformation/Functions/reduction.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/Functions/reduction.hpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/Functions/reduction.hpp	(revision 1545)
@@ -23,5 +23,4 @@
 {
 public:
-  //static std::map<StdString,EReductionType> ReductionOperations;
   static std::map<StdString,EReductionType> *ReductionOperations_ptr;
   #pragma omp threadprivate(ReductionOperations_ptr)
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1545)
@@ -13,5 +13,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-//#include "reduction.hpp"
 
 namespace xios {
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_inverse.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_inverse.cpp	(revision 1545)
@@ -109,5 +109,5 @@
   }
 
-  typedef boost::unordered_map<size_t, std::vector<double> > GlobalIndexMapFromSrcToDest;
+  typedef std::unordered_map<size_t, std::vector<double> > GlobalIndexMapFromSrcToDest;
   GlobalIndexMapFromSrcToDest globalIndexMapFromSrcToDest;
   TransformationIndexMap& transMap = this->transformationMapping_[0];
@@ -127,5 +127,5 @@
   dhtIndexProcRank.computeIndexInfoMapping(globalSrcIndex);
   CClientClientDHTInt::Index2VectorInfoTypeMap& computedGlobalIndexOnProc = dhtIndexProcRank.getInfoIndexMap();
-  boost::unordered_map<int, std::vector<size_t> > globalSrcIndexSendToProc;
+  std::unordered_map<int, std::vector<size_t> > globalSrcIndexSendToProc;
   for (int idx = 0; idx < localIndex; ++idx)
   {
@@ -138,5 +138,5 @@
   }
 
-  boost::unordered_map<int, std::vector<size_t> >::const_iterator itbIndex = globalSrcIndexSendToProc.begin(), itIndex,
+  std::unordered_map<int, std::vector<size_t> >::const_iterator itbIndex = globalSrcIndexSendToProc.begin(), itIndex,
                                                                   iteIndex = globalSrcIndexSendToProc.end();
   std::map<int,int> sendRankSizeMap,recvRankSizeMap;
@@ -176,6 +176,6 @@
   std::vector<MPI_Request> requests;
   std::vector<MPI_Status> status;
-  boost::unordered_map<int, unsigned long* > recvGlobalIndexSrc;
-  boost::unordered_map<int, double* > sendValueToDest;
+  std::unordered_map<int, unsigned long* > recvGlobalIndexSrc;
+  std::unordered_map<int, double* > sendValueToDest;
   for (std::map<int,int>::const_iterator itRecv = recvRankSizeMap.begin(); itRecv != recvRankSizeMap.end(); ++itRecv)
   {
@@ -189,6 +189,6 @@
   }
 
-  boost::unordered_map<int, unsigned long* > sendGlobalIndexSrc;
-  boost::unordered_map<int, double* > recvValueFromSrc;
+  std::unordered_map<int, unsigned long* > sendGlobalIndexSrc;
+  std::unordered_map<int, double* > recvValueFromSrc;
   for (itIndex = itbIndex; itIndex != iteIndex; ++itIndex)
   {
@@ -272,10 +272,10 @@
   delete [] recvSizeBuff;
 
-  boost::unordered_map<int, double* >::const_iterator itChar;
+  std::unordered_map<int, double* >::const_iterator itChar;
   for (itChar = sendValueToDest.begin(); itChar != sendValueToDest.end(); ++itChar)
     delete [] itChar->second;
   for (itChar = recvValueFromSrc.begin(); itChar != recvValueFromSrc.end(); ++itChar)
     delete [] itChar->second;
-  boost::unordered_map<int, unsigned long* >::const_iterator itLong;
+  std::unordered_map<int, unsigned long* >::const_iterator itLong;
   for (itLong = sendGlobalIndexSrc.begin(); itLong != sendGlobalIndexSrc.end(); ++itLong)
     delete [] itLong->second;
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_axis.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_axis.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_axis.cpp	(revision 1545)
@@ -12,5 +12,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-//#include "reduction.hpp"
 
 namespace xios {
@@ -72,5 +71,5 @@
     CReductionAlgorithm::initReductionOperation();
   }
-  //reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+
   reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations_ptr->at(op));
 }
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1545)
@@ -13,5 +13,5 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-//#include "reduction.hpp"
+
 
 namespace xios {
@@ -74,5 +74,4 @@
     CReductionAlgorithm::initReductionOperation();
   }
-  //reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
   reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations_ptr->at(op));
   local = algo->local ;
Index: XIOS/dev/branch_openmp/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/domain_algorithm_interpolate.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/domain_algorithm_interpolate.cpp	(revision 1545)
@@ -8,5 +8,5 @@
  */
 #include "domain_algorithm_interpolate.hpp"
-#include <boost/unordered_map.hpp>
+#include <unordered_map>
 #include "context.hpp"
 #include "context_client.hpp"
@@ -406,11 +406,7 @@
   CContext* context = CContext::getCurrent();
   CContextClient* client=context->client;
-  //int mykey;
-  //ep_lib::MPI_Comm_rank(client->intraComm, &mykey);
 
   ep_lib::MPI_Comm poleComme = MPI_COMM_NULL;
   ep_lib::MPI_Comm_split(client->intraComm, interMapValuePole.empty() ? 0 : 1, 0, &poleComme);
-  //ep_lib::MPI_Comm_split(client->intraComm, interMapValuePole.empty() ? 0 : 1, mykey, &poleComme);
-  //if (!poleComme.is_null())
   if (poleComme!=MPI_COMM_NULL)
   {
@@ -540,5 +536,5 @@
   TransformationWeightMap& transWeight = this->transformationWeight_[0];
 
-  boost::unordered_map<size_t,int> globalIndexOfDomainDest;
+  std::unordered_map<size_t,int> globalIndexOfDomainDest;
   int ni = domainDest_->ni.getValue();
   int nj = domainDest_->nj.getValue();
@@ -816,6 +812,5 @@
   WriteNetCdf *netCdfWriter;
 
-//  #pragma omp barrier
-//  #pragma omp master
+
   MPI_Barrier_local(client->intraComm);
   if(my_rank_loc==0)
@@ -843,5 +838,5 @@
   }
   
-//  #pragma omp barrier
+
   MPI_Barrier_local(client->intraComm);
   
@@ -863,6 +858,5 @@
   MPI_Barrier_local(client->intraComm);
   
-//  #pragma omp barrier
-  cout<<"end write weight info"<< endl;
+
 }
 
@@ -953,5 +947,5 @@
        renormalizationFactor=1 ;
      }
-     
+
     if (firstPass)
     {
@@ -969,5 +963,6 @@
       else
       {
-        dataOut(localIndex[idx].first) += *(dataInput + idx) * localIndex[idx].second;   
+        dataOut(localIndex[idx].first) += *(dataInput + idx) * localIndex[idx].second;
+        allMissing(localIndex[idx].first) = allMissing(localIndex[idx].first) && false; // Reset flag to indicate not all data source are nan
       }
     }
@@ -999,7 +994,7 @@
       if (renormalizationFactor.numElements()>0) dataOut/=renormalizationFactor ; // In some case, process doesn't received any data for interpolation (mask)
                                                                                  // so renormalizationFactor is not initialized
-    }    
-  }
-}
-
-}
+    }
+  }
+}
+
+}
Index: XIOS/dev/branch_openmp/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/generic_algorithm_transformation.cpp	(revision 1544)
+++ XIOS/dev/branch_openmp/src/transformation/generic_algorithm_transformation.cpp	(revision 1545)
@@ -51,4 +51,5 @@
       }
     }
+
   }
   else
@@ -164,5 +165,5 @@
   int nbClient = client->clientSize;
 
-  typedef boost::unordered_map<int, std::vector<std::pair<int,double> > > SrcToDstMap;
+  typedef std::unordered_map<int, std::vector<std::pair<int,double> > > SrcToDstMap;
   int idx;
 
@@ -286,5 +287,5 @@
         if (idx != elementPositionInGrid)
         {
-          boost::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
+          std::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
                                                                    ite = globalElementIndexOnProc_[idx].end();
           for (it = itb; it != ite; ++it) it->second.resize(1);
@@ -300,5 +301,5 @@
         if (idx != elementPositionInGrid)
         {
-          boost::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
+          std::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
                                                                    ite = globalElementIndexOnProc_[idx].end();
           for (it = itb; it != ite; ++it) procOfNonTransformedElements_.insert(it->first);
@@ -358,5 +359,5 @@
           set<int> tmpSet ; 
           procList.swap(tmpSet) ;
-          boost::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
+          std::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
                                                                    ite = globalElementIndexOnProc_[idx].end();
           for (it = itb; it != ite; ++it)
@@ -394,5 +395,5 @@
 
     // Build mapping between global source element index and global destination element index.
-    boost::unordered_map<int,std::vector<size_t> >().swap(globalElementIndexOnProc_[elementPositionInGrid]);
+    std::unordered_map<int,std::vector<size_t> >().swap(globalElementIndexOnProc_[elementPositionInGrid]);
     std::set<int> tmpCounter;
     itTransWeight = itbTransWeight;
@@ -425,5 +426,5 @@
         if (idx != elementPositionInGrid)
         {
-          boost::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
+          std::unordered_map<int,std::vector<size_t> >::iterator itb = globalElementIndexOnProc_[idx].begin(), it,
                                                                    ite = globalElementIndexOnProc_[idx].end();
           for (it = itb; it != ite; ++it) it->second[0] = transPos(idxTrans);
@@ -455,8 +456,8 @@
 void CGenericAlgorithmTransformation::computeGlobalGridIndexMapping(int elementPositionInGrid,
                                                                    const std::vector<int>& srcRank,
-                                                                   boost::unordered_map<int, std::vector<std::pair<int,double> > >& src2DstMap,
+                                                                   std::unordered_map<int, std::vector<std::pair<int,double> > >& src2DstMap,
                                                                    CGrid* gridSrc,
                                                                    CGrid* gridDst,
-                                                                   std::vector<boost::unordered_map<int,std::vector<size_t> > >& globalElementIndexOnProc,
+                                                                   std::vector<std::unordered_map<int,std::vector<size_t> > >& globalElementIndexOnProc,
                                                                    SourceDestinationIndexMap& globaIndexWeightFromSrcToDst)
 {
@@ -614,5 +615,5 @@
  
       SourceDestinationIndexMap::iterator rankIt,rankIte ;
-      boost::unordered_map<size_t, std::vector<std::pair<size_t,double> > >::iterator globalSrcIndexIt, globalSrcIndexIte ;
+      std::unordered_map<size_t, std::vector<std::pair<size_t,double> > >::iterator globalSrcIndexIt, globalSrcIndexIte ;
       std::vector<std::pair<size_t,double> >::iterator vectIt,vectIte ;
    
@@ -652,5 +653,5 @@
                                                                  CScalar* scalarSrc,
                                                                  CArray<size_t,1>& destGlobalIndexPositionInGrid,
-                                                                 boost::unordered_map<int,std::vector<size_t> >& globalScalarIndexOnProc)
+                                                                 std::unordered_map<int,std::vector<size_t> >& globalScalarIndexOnProc)
 {
   CContext* context = CContext::getCurrent();
@@ -676,5 +677,5 @@
                                                                CAxis* axisSrc,
                                                                CArray<size_t,1>& destGlobalIndexPositionInGrid,
-                                                               boost::unordered_map<int,std::vector<size_t> >& globalAxisIndexOnProc)
+                                                               std::unordered_map<int,std::vector<size_t> >& globalAxisIndexOnProc)
 {
   CContext* context = CContext::getCurrent();
@@ -745,5 +746,5 @@
                                                                  CDomain* domainSrc,
                                                                  CArray<size_t,1>& destGlobalIndexPositionInGrid,
-                                                                 boost::unordered_map<int,std::vector<size_t> >& globalDomainIndexOnProc)
+                                                                 std::unordered_map<int,std::vector<size_t> >& globalDomainIndexOnProc)
 {
   CContext* context = CContext::getCurrent();
